import { BigNumber } from "ethers-wan/utils";
import { BaseWallet, WanWallet } from "../wallets";
export declare const WALLET_STEPS: {
    SELECT: string;
    CREATE: string;
    CREATE_CONFIRM: string;
    BACKUP: string;
    TEST_MNEMONIC: string;
    ADD_FUNDS: string;
    IMPORT: string;
    DELETE: string;
};
export declare const destoryTimer: () => void;
export declare const cacheWallet: (wallet: WanWallet, password: string) => {
    type: string;
    payload: {
        wallet: WanWallet;
        password: string;
    };
};
export declare const setUnit: (unit: string, decimals: number) => {
    type: string;
    payload: {
        unit: string;
        decimals: number;
    };
};
export declare const initCustomLocalWallet: (walletClass: any) => {
    type: string;
    payload: {
        walletClass: any;
    };
};
export declare const selectWalletType: (type: string) => {
    type: string;
    payload: {
        type: string;
    };
};
export declare const setTranslations: (translations: {
    [key: string]: string;
}) => {
    type: string;
    payload: {
        translations: {
            [key: string]: string;
        };
    };
};
export declare const setWalletStep: (step: string) => {
    type: string;
    payload: {
        step: string;
    };
};
export declare const initAccount: (accountID: string, wallet: BaseWallet) => {
    type: string;
    payload: {
        accountID: string;
        wallet: BaseWallet;
    };
};
export declare const updateWallet: (wallet: BaseWallet) => {
    type: string;
    payload: {
        wallet: BaseWallet;
    };
};
export declare const loadAddress: (accountID: string, address: string | null) => {
    type: string;
    payload: {
        accountID: string;
        address: string | null;
    };
};
export declare const loadBalance: (accountID: string, balance: BigNumber) => {
    type: string;
    payload: {
        accountID: string;
        balance: BigNumber;
    };
};
export declare const loadNetwork: (accountID: string, networkId: number | undefined) => {
    type: string;
    payload: {
        accountID: string;
        networkId: number | undefined;
    };
};
export declare const selectAccount: (accountID: string, type: string) => (dispatch: any, getState: any) => Promise<void>;
export declare const supportExtensionWallet: () => {
    type: string;
};
export declare const supportLightWallet: () => {
    type: string;
};
export declare const lockAccount: (accountID: string) => {
    type: string;
    payload: {
        accountID: string;
    };
};
export declare const unlockAccount: (accountID: string) => {
    type: string;
    payload: {
        accountID: string;
    };
};
export declare const unlockBrowserWalletAccount: (account: import("../reducers").ImmutableMap<import("../reducers/wallet").AccountProps>, password: string) => (dispatch: any) => Promise<void>;
export declare const deleteBrowserWalletAccount: (account: import("../reducers").ImmutableMap<import("../reducers/wallet").AccountProps>) => (dispatch: any) => Promise<void>;
export declare const showWalletModal: () => {
    type: string;
};
export declare const hideWalletModal: () => {
    type: string;
};
export declare const loadWallet: (type: string, action?: any) => (dispatch: any, getState: any) => any;
export declare const loadExtensitonWallet: () => (dispatch: any) => Promise<void>;
export declare const loadLightWallet: () => (dispatch: any) => Promise<void>;
export declare const loadLocalWallets: () => (dispatch: any, getState: any) => void;
export declare const loadLedger: () => (dispatch: any) => Promise<void>;
export declare const connectLedger: () => {
    type: string;
};
export declare const disconnectLedger: () => {
    type: string;
};
export declare const loadTrezor: () => (dispatch: any) => Promise<void>;
export declare const connectTrezor: () => {
    type: string;
};
export declare const disconnectTrezor: () => {
    type: string;
};
export declare const watchWallet: (wallet: BaseWallet) => (dispatch: any, getState: any) => Promise<void>;
