import * as React from "react";
import { Ledger } from "../../wallets";
import { BigNumber } from "bignumber.js";
interface Props {
    dispatch: any;
    wallet: Ledger | null;
    isLocked: boolean;
    ledgerConnecting: boolean;
    walletTranslations: {
        [key: string]: any;
    };
    copyCallback?: (text: string) => any;
}
interface State {
    loading: boolean;
    addresses: {
        [key: string]: string;
    };
    balances: {
        [key: string]: BigNumber;
    };
    pathType: string;
    realPath: string;
    index: number;
    currentAddress: string | null;
    currentPage: number;
    gotoPageInputValue: number;
}
declare class LedgerConnector extends React.PureComponent<Props, State> {
    constructor(props: Props);
    componentDidMount(): void;
    componentDidUpdate(prevProps: Props, prevState: State): void;
    render(): JSX.Element;
    private renderContent;
    private renderCustomizedPath;
    private handleChangeCustomizedPath;
    private selectPath;
    private getPathOptions;
    private getAddressOptions;
    private renderFooter;
    private gotoPageSubmit;
    private changePage;
    private loadAddresses;
    selectAccount(address: string, path: string): void;
    private connectLedger;
    private loadBalances;
}
declare const _default: import("react-redux").ConnectedComponent<typeof LedgerConnector, Pick<Props, "copyCallback">>;
export default _default;
