import * as React from "react";
import { Option } from "./Select";
import { AccountState } from "../../reducers/wallet";
import { Map } from "immutable";
declare global {
    interface Window {
        web3: any;
        injectWeb3: any;
    }
}
interface State {
    password: string;
    processing: boolean;
    checkbox: boolean;
}
interface Props {
    dispatch: any;
    nodeUrl?: string;
    defaultWalletType?: string;
    translations?: {
        [key: string]: any;
    };
    walletTranslations: {
        [key: string]: any;
    };
    selectedAccount: AccountState | null;
    accounts: Map<string, AccountState>;
    extensionWalletSupported: boolean;
    lightWalletSupported: boolean;
    isShowWalletModal: boolean;
    step: string;
    walletTypes?: string[];
    loadWalletActions?: {
        [key: string]: any;
    };
    menuOptions?: Option[];
    selectedWalletType: string;
    customLocalWallet?: any;
    LocalWallet: any;
    hideLocalWallet?: boolean;
    unit?: string;
    decimals?: number;
    copyCallback?: (text: string) => any;
    appName?: string;
    appLogoUrl?: string;
}
declare class Wallet extends React.PureComponent<Props, State> {
    constructor(props: Props);
    componentDidMount(): void;
    componentDidUpdate(prevProps: Props): void;
    componentWillUnmount(): void;
    private loadExtensitonWallet;
    render(): JSX.Element;
    private renderStepContent;
    private renderUnlockForm;
    private renderDeleteForm;
    private handleDelete;
    private handleUnlock;
    private getWalletsOptions;
    private localWalletOptions;
}
declare const _default: import("react-redux").ConnectedComponent<typeof Wallet, Pick<Props, "unit" | "decimals" | "copyCallback" | "nodeUrl" | "defaultWalletType" | "translations" | "walletTypes" | "loadWalletActions" | "menuOptions" | "customLocalWallet" | "hideLocalWallet" | "appName" | "appLogoUrl">>;
export default _default;
