import { Map } from "immutable";
import { BigNumber } from "bignumber.js";
import { ImmutableMap } from ".";
import { BaseWallet, WanWallet } from "../wallets";
export interface AccountProps {
    address: string | null;
    balance: BigNumber;
    isLocked: boolean;
    networkId: number | null;
    wallet: BaseWallet;
}
export declare type AccountState = ImmutableMap<AccountProps>;
export declare const initializeAccount: AccountState;
export interface WalletProps {
    accounts: Map<string, AccountState>;
    selectedAccountID: string | null;
    selectedWalletType: string;
    extensionWalletSupported: boolean;
    lightWalletSupported: boolean;
    ledgerConnecting: boolean;
    trezorConnecting: boolean;
    isShowWalletModal: boolean;
    step: string;
    walletCache: {
        wallet: WanWallet;
        password: string;
    };
    walletTranslations: {
        [key: string]: any;
    };
    LocalWallet: WanWallet | null;
    unit: string;
    decimals: number;
}
export declare type WalletState = ImmutableMap<WalletProps>;
declare const _default: (state: ImmutableMap<WalletProps> | undefined, action: any) => ImmutableMap<WalletProps>;
export default _default;
