export interface txParams {
    Txtype?: string;
    from?: string;
    to: string;
    data?: string;
    value?: number | string | BigNumber;
    gasPrice?: number | string | BigNumber;
    gasLimit?: number | string | BigNumber;
    nonce?: number;
}
import { BigNumber } from "ethers-wan/utils";
export default abstract class baseWallet {
    static NeedUnlockWalletError: Error;
    static NotSupportedError: Error;
    abstract signMessage(message: string): Promise<string> | null;
    abstract signPersonalMessage(message: string | Uint8Array): Promise<string>;
    abstract sendTransaction(txParams: txParams): Promise<string | undefined>;
    abstract type(): string;
    abstract id(): string;
    abstract getAddresses(): Promise<string[]>;
    abstract isSupported(): boolean;
    abstract isLocked(address: string | null): boolean;
    abstract loadNetworkId(): Promise<number | undefined>;
    abstract sendCustomRequest(method: string, params: any): Promise<any>;
    getBalance(address: string): Promise<BigNumber>;
    abstract name(): string;
}
