import BaseWallet, { txParams } from "./baseWallet";
declare global {
    interface Window {
        wan3: any;
        ethereum?: any;
        alertAntd?: any;
    }
}
export default class ExtensionWallet extends BaseWallet {
    static LABEL: string;
    static TYPE: string;
    type(): string;
    id(): string;
    loadNetworkId(): Promise<number | undefined>;
    signMessage(message: string | Uint8Array): Promise<string> | null;
    signPersonalMessage(message: string | Uint8Array): Promise<string>;
    sendTransaction(txParams: txParams): Promise<string | undefined>;
    sendCustomRequest(method: string, params?: any): Promise<any>;
    getAddresses(): Promise<string[]>;
    static enableBrowserExtensionWallet(): Promise<void>;
    isLocked(address: string | null): boolean;
    isSupported(): boolean;
    name(): string;
}
