import { Wallet } from "ethers-wan";
import BaseWallet, { txParams } from "./baseWallet";
export default class WanWallet extends BaseWallet {
    private static TIMEOUT;
    private static WALLETS_KEY;
    private static _cache;
    static TYPE: string;
    static LABEL: string;
    private static nodeUrl;
    _address: string | null;
    _wallet: Wallet | null;
    private _timer?;
    private _provider?;
    private constructor();
    static createRandom(): Promise<WanWallet>;
    static import(privateKey: string, password: string): Promise<WanWallet>;
    static fromMnemonic(mnemonic: string, password: string, path?: string): Promise<WanWallet>;
    save(password: string): Promise<boolean>;
    delete(): boolean;
    static setNodeUrl(nodeUrl: string): void;
    type(): string;
    id(): string;
    static list(): WanWallet[];
    private static setWalletData;
    private static getWalletData;
    private static parseWalletAddress;
    private static getWallet;
    signMessage(message: string | Uint8Array): Promise<string>;
    signPersonalMessage(message: string | Uint8Array): Promise<string>;
    sendTransaction(txParams: txParams): Promise<string | undefined>;
    sendCustomRequest(method: string, params: any): Promise<any>;
    getAddresses(): Promise<string[]>;
    loadNetworkId(): Promise<number | undefined>;
    lock(): Promise<void>;
    unlock(password: string): Promise<void>;
    isLocked(): boolean;
    isSupported(): boolean;
    private getProvider;
    getMnemonic(): string;
    getPrivateKey(): string;
    private resetTimeout;
    name(): string;
}
