import WanWallet from "./hydroWallet";
import ExtensionWallet from "./extensionWallet";
import BaseWallet from "./baseWallet";
import Ledger from "./ledger";
import Trezor from "./trezor";
import LightWallet from "./lightWallet";
import { BigNumber } from "ethers-wan/utils";
import { Contract } from "ethers-wan";
declare const NeedUnlockWalletError: Error, NotSupportedError: Error;
export declare let globalNodeUrl: string;
export { BaseWallet, WanWallet, ExtensionWallet, NeedUnlockWalletError, NotSupportedError, Ledger, Trezor, LightWallet };
export declare const payloadId: () => number;
export declare const setGlobalNodeUrl: (nodeUrl: string) => void;
export declare const truncateAddress: (address: string) => string;
export declare const getNetworkID: () => Promise<number>;
export declare const sendRawTransaction: (data: string) => Promise<string>;
export declare const getBalance: (address: string) => Promise<BigNumber>;
export declare const getTransactionReceipt: (txID: string) => Promise<any>;
export declare const getEstimateGas: (params: any) => Promise<any>;
export declare const getTransactionCount: (address: string, status?: string) => Promise<number>;
export declare const getContract: (contractAddress: string, abi: any) => Contract;
export declare const defaultWalletTypes: string[];
