import { BaseWallet } from ".";
import { txParams } from "./baseWallet";
export default class Ledger extends BaseWallet {
    static LABEL: string;
    static TYPE: string;
    private awaitLock;
    private eth;
    ethAppVersion: string;
    static PATH_TYPE: {
        LEDGER_LIVE: string;
        LEGACY: string;
        WAN: string;
    };
    static currentBasePath: string;
    static currentIndex: number;
    connected: boolean;
    static CUSTOMIZAION_PATH: string;
    static PREFIX_ETHEREUM_PATH: string;
    constructor();
    initTransport(): Promise<void>;
    static getPathType(basePath: string): string;
    static setPath(basePath: string, index: number): void;
    currentPath(): string;
    type(): string;
    id(): string;
    ledgerAlert(info: string): void;
    signMessage(message: string): Promise<string> | null;
    signPersonalMessage(message: string): Promise<string>;
    signTransaction(txParams: txParams): Promise<string>;
    sendTransaction(txParams: txParams): Promise<string>;
    getAddressesWithPath(basePath: string, from: number, count: number): Promise<{
        [key: string]: string;
    }>;
    getAddresses(): Promise<string[]>;
    isSupported(): boolean;
    isLocked(): boolean;
    loadNetworkId(): Promise<number>;
    sendCustomRequest(method: string, params: any): Promise<any>;
    name(): string;
    toHexString(value: any): string;
}
